//
//  ViewController.swift
//  UniversalBsp
//
//  Created by Christian Bleske on 11.03.15.
//  Copyright (c) 2015 Christian Bleske. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    @IBOutlet weak var uiImageView: UIImageView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        let screenSize: CGRect = UIScreen.mainScreen().nativeBounds
        
        let screenWidth = screenSize.width
        let screenHeight = screenSize.height
        
        print("Width=\(screenWidth)")
        print("Height=\(screenHeight)")
        
        switch (screenHeight) {
            case 960:
                self.uiImageView.image = UIImage(named: "background-960@2x.png")!
                break;
            case 1136:
                self.uiImageView.image = UIImage(named: "background-1136@2x.png")!
                break;
            case 1334:
                self.uiImageView.image = UIImage(named: "background-1334@2x.png")!
                break;
            case 2208:
                self.uiImageView.image = UIImage(named: "background-2208@3x.png")!
                break;
            case 1024:
                self.uiImageView.image = UIImage(named: "background-1024.png")!
                break;
            case 2048:
                self.uiImageView.image = UIImage(named: "background-2048@2x.png")!
                break;
            default:
                break;
        }
        
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    @IBAction func button_Pressed(sender: AnyObject) {
        if UIDevice.currentDevice().userInterfaceIdiom == UIUserInterfaceIdiom.Pad {
            self.showAlertViewWithTitle("Neues Spiel", message: "iPad-Version...")
        }
        
        if UIDevice.currentDevice().userInterfaceIdiom == UIUserInterfaceIdiom.Phone {
            self.showAlertViewWithTitle("Neues Spiel", message: "iPhone-Version...")
        }
    }
    
    override func viewWillTransitionToSize(size: CGSize, withTransitionCoordinator coordinator: UIViewControllerTransitionCoordinator) {
        if UIDevice.currentDevice().orientation.isLandscape.boolValue {
            print("Landscape-Mode")
        } else {
            print("Portrait-Mode")
        }
    }
    
    func showAlertViewWithTitle(title:String, message:String) {
        
        let alertController = UIAlertController(title: title, message: message, preferredStyle: .Alert)
        
        
        let OKAction = UIAlertAction(title: "OK", style: .Default) { (action) in
            // ...
        }
        
        alertController.addAction(OKAction)
        
        self.presentViewController(alertController, animated: true) {
            // ...
        }
        
    }

}

