//
//  ViewController.swift
//  TouchBsp
//
//  Created by Christian Bleske on 27.12.14.
//  Copyright (c) 2014 Christian Bleske. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    @IBOutlet weak var uiLabel: UILabel!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        self.view.userInteractionEnabled = true
        
        let singleTabGesture = UITapGestureRecognizer(target: self, action: "handleSingleTapGesture:")
        singleTabGesture.numberOfTapsRequired = 1
        self.view.addGestureRecognizer(singleTabGesture)

        let doubleTabGesture = UITapGestureRecognizer(target: self, action: "handleDoubleTapGesture:")
        doubleTabGesture.numberOfTapsRequired = 2
        self.view.addGestureRecognizer(doubleTabGesture)
        
        let rightSwipe = UISwipeGestureRecognizer(target: self, action: "handleRightSwipeGesture:")
        rightSwipe.direction = UISwipeGestureRecognizerDirection.Right
        self.view.addGestureRecognizer(rightSwipe)
        
        let leftSwipe = UISwipeGestureRecognizer(target: self, action: "handleLeftSwipeGesture:")
        leftSwipe.direction = UISwipeGestureRecognizerDirection.Left
        self.view.addGestureRecognizer(leftSwipe)
        
        let pinchGesture = UIPinchGestureRecognizer(target: self, action: "handlePinchGesture:")
        self.view.addGestureRecognizer(pinchGesture)

    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    func handleSingleTapGesture(gestureRecognizer: UITapGestureRecognizer)
    {
        uiLabel.text = "Einfacher Tab"
    }
    
    func handleDoubleTapGesture(gestureRecognizer: UITapGestureRecognizer)
    {
        uiLabel.text = "Doppelter Tab"
    }
    
    func handleRightSwipeGesture(gestureRecognizer: UISwipeGestureRecognizer)
    {
        uiLabel.text = "Swipe Geste rechts"
    }
    
    func handleLeftSwipeGesture(gestureRecognizer: UISwipeGestureRecognizer)
    {
        uiLabel.text = "Swipe Geste links"
    }
    
    func handlePinchGesture(gestureRecognizer: UISwipeGestureRecognizer)
    {
        uiLabel.text = "Pinch Geste"
    }


}

