//
//  DetailViewController.swift
//  AirDropBspSwt
//
//  Created by Christian Bleske on 20.08.14.
//  Copyright (c) 2014 Christian Bleske. All rights reserved.
//

import UIKit

class DetailViewController: UIViewController {
    
    @IBOutlet var uiwebView: UIWebView!
    @IBAction func button_pressed(sender: AnyObject) {
        let fileUrl = self.getFilePath(self.detailItem as! String)

        let uiActivityViewController : UIActivityViewController = UIActivityViewController(activityItems: [fileUrl], applicationActivities: nil)
        
        let excludedActivitiesTypes:NSArray = [UIActivityTypePostToTwitter, UIActivityTypePostToFacebook,
        UIActivityTypePostToWeibo,
        UIActivityTypeMessage, UIActivityTypeMail,
        UIActivityTypePrint, UIActivityTypeCopyToPasteboard,
        UIActivityTypeAssignToContact, UIActivityTypeSaveToCameraRoll,
        UIActivityTypeAddToReadingList, UIActivityTypePostToFlickr,
        UIActivityTypePostToVimeo, UIActivityTypePostToTencentWeibo]
        
        uiActivityViewController.excludedActivityTypes = excludedActivitiesTypes as? [String]
        
        self.navigationController!.presentViewController(uiActivityViewController, animated: true, completion: nil)
        
    }


    var detailItem: AnyObject? {
        didSet {
            // Update the view.
            self.configureView()
        }
    }

    func configureView() {
        // Update the user interface for the detail item.
        if let detail: AnyObject = self.detailItem {
        }
    }

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        self.configureView()
        
        let fileUrl = self.getFilePath(self.detailItem as! String)
        let request = NSURLRequest(URL: fileUrl)
        self.uiwebView.loadRequest(request)
    }
    
    func getFilePath(filename:NSString)-> NSURL {
        var filenameSeparated:[String]
        filenameSeparated = filename.componentsSeparatedByString(".") as [String]
        //var myArray = filename.componentsSeparatedByString(".")
        let path = NSBundle.mainBundle().pathForResource(filenameSeparated[0] as String, ofType: filenameSeparated[1] as String)
        let fileWithPath = NSURL.fileURLWithPath(path!)
        return fileWithPath
    }
    

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }


}

