//
//  ViewController.swift
//  iCloudBsp
//
//  Created by Christian Bleske on 13.02.15.
//  Copyright (c) 2015 Christian Bleske. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    @IBOutlet var uiTextField: UITextField!
    
    let keyStore = NSUbiquitousKeyValueStore()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        let textString = keyStore.stringForKey("TEXT_ENTRY") as NSString?
        
        if (textString != nil){
            self.uiTextField.text = textString as? String
        } else {
            self.uiTextField.text = "Keine Daten!"
        }
        
        NSNotificationCenter.defaultCenter().addObserver(self, selector: "ubiquitousKeyValueStoreDidChange:", name: NSUbiquitousKeyValueStoreDidChangeExternallyNotification, object: keyStore)

    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    @IBAction func btnSaveText_Pressed(sender: AnyObject) {
        saveValue()
    }
    
    func saveValue()
    {
        keyStore.setString(uiTextField.text, forKey: "TEXT_ENTRY")
        keyStore.synchronize()
    }
    
    func ubiquitousKeyValueStoreDidChange (notification:NSNotification) {
        showAlertViewWithTitle("Achtung Aktualisierung!",message: "Im iCloud key-value store wurde eine Änderung festgestellt.")
        self.uiTextField.text = keyStore.stringForKey("TEXT_ENTRY")

    }
    
    func showAlertViewWithTitle(title:String, message:String) {
        let alertController = UIAlertController(title: title, message: message, preferredStyle: .Alert)
        
        let OKAction = UIAlertAction(title: "OK", style: .Default) { (action) in
        }
        
        alertController.addAction(OKAction)
        
        self.presentViewController(alertController, animated: true) {
        }
        
    }


}

